package at.jku.students.set.tree;

import at.jku.ssw.set.impl.InOrderTreeIterator;
import at.jku.ssw.util.Out;

public class TreeSetMain {

	public static void main(String[] args) {
		BinaryTreeSet set = new BinaryTreeSet();

		set.add('g');

		set.add('m');

		set.add('e');
		set.add('f');

		set.add('b');
		set.add('a');
		set.add('c');

		set.add('k');
		set.remove('m');

		set.add('i');
		set.add('w');
		set.add('f');
		set.add('l');
		set.remove('w');

		System.out.println("Height:" + set.height());
		System.out.println("Width:" + set.width());

		makeDot(set, "set1.dot");
		printInOrder(set);

		System.out.println(set.treeString());
	}

	private static void printInOrder(BinaryTreeSet set) {
		InOrderTreeIterator it = new InOrderTreeIterator(set.getRoot());
		System.out.print("  In-Order:");
		while (it.hasNext()) {
			System.out.print(it.next() + " ");
		}
		System.out.println();
	}

	static void makeDot(BinaryTreeSet set, String filename) {
		Out.open(filename);
		Out.print(set.makeDot());
		Out.close();
	}
}
